//By linkcd 
//http://linkcd.cnblogs.com/

using System;
using System.Collections.Generic;
using System.Text;
using ArgsUtility.ArgumentMarshaler;
using System.Collections;

namespace ArgsUtility
{
    public class Args
    {
        //ArgumentName:ArgumentMashaler
        private Dictionary<char, ArgumentMarshalerBase> _myArgumentMashalers = new Dictionary<char, ArgumentMarshalerBase>();
        
        //ArgumentName:ArgumentValue
        private Dictionary<char, string> _myArgumentValues = new Dictionary<char,string>();

        public Args(string schema, string[] argumens) 
        {
            this.ParseSchema(schema);
            this.ParseArgumentStrings(argumens);
        }

        private void ParseSchema(string schema)
        {
            if (string.IsNullOrEmpty(schema))
            {
                throw new Exception("Null Schema");
            }

            foreach (string s in schema.Split(','))
            {
                string schemaNameAndSymbol = s.Trim();
                ValidateSchemaElement(schemaNameAndSymbol);

                char argumentName = schemaNameAndSymbol[0];
                char argumentTypeSymbol = schemaNameAndSymbol[1];

                ArgumentMarshalerBase amb = SupportedArguments.Instance.GetArgumentMarshaler(argumentTypeSymbol);
                this._myArgumentMashalers.Add(argumentName, amb);
            }
        }

        private  void ValidateSchemaElement(string s)
        {
            //each schema element should like this: 'x*', only two char
            if (s.Length != 2)
            {
                throw new Exception("Bad Schema: " + s);
            }
        }

        private void ParseArgumentStrings(string[] values)
        {
            IEnumerator ie = values.GetEnumerator();

            //ugly code, i think, but all tests can pass, so let me ignore it at this time.
            while (ie.MoveNext())
            {
                if (ie.Current.ToString().StartsWith("-"))
                {
                    char argumentName = ie.Current.ToString()[1];
                    
                    if (ie.MoveNext())
                    {
                        string argumentValue = ie.Current.ToString();
                        this._myArgumentValues.Add(argumentName, argumentValue);
                    }
                }
            }
        }

        public object this[char argumentName]
        {
            get
            {
                ArgumentMarshalerBase amb;
                if (this._myArgumentMashalers.ContainsKey(argumentName))
                {
                    amb = this._myArgumentMashalers[argumentName];
                }
                else
                {
                    throw new Exception(string.Format("Argument {0} unexpected.", argumentName));
                }

                string argumentValue;
                if (this._myArgumentValues.ContainsKey(argumentName))
                {
                    argumentValue = this._myArgumentValues[argumentName];
                }
                else
                {
                    throw new Exception(string.Format("Can't find {0} parameter for {1}.", amb.ArgumentType, argumentName));
                }

                return amb.ParseInputValue(argumentValue);
                
            }
        }
    }
}
