//By linkcd 
//http://linkcd.cnblogs.com/

using System;
using System.Collections.Generic;
using System.Text;

namespace ArgsUtility.ArgumentMarshaler
{
    abstract class ArgumentMarshalerBase
    {
        private char _schemaSymbol;
        public ArgumentMarshalerBase(char schemaSymbol)
        {
            this._schemaSymbol = schemaSymbol;
        }

        public bool IsSymbolMatched(char targetSymbol)
        {
            return targetSymbol == this._schemaSymbol;
        }

        public object ParseInputValue(string value)
        {
            try
            {
                return this.DoParse(value);
            }
            catch (FormatException ex)
            {
                //catch all format problems
                throw new Exception(string.Format("'{0}' is an invalid {1} format.", value, this.ArgumentType),ex);
            }

        }

        abstract protected object DoParse(string value);
        abstract public string ArgumentType
        {
            get;
        }
                      
    }
}
