//By linkcd 
//http://linkcd.cnblogs.com/

using System;
using System.Collections.Generic;
using System.Text;

namespace ArgsUtility.ArgumentMarshaler
{
    class SupportedArguments
    {
        private List<ArgumentMarshalerBase> _commonArgs = new List<ArgumentMarshalerBase>();
        readonly public static SupportedArguments Instance = new SupportedArguments();

        private SupportedArguments()
        {
            this._commonArgs.Add(new BooleanArgumentMarshaler());
            this._commonArgs.Add(new IntegerArgumentMarshaler());
            this._commonArgs.Add(new DoubleArgumentMashaler());
            this._commonArgs.Add(new StringArgumentMashaler());
            //todo: add more argumentMarshalers
        }

        public ArgumentMarshalerBase GetArgumentMarshaler(char typeSymbol)
        {
            foreach (ArgumentMarshalerBase amb in this._commonArgs)
            {
                if (amb.IsSymbolMatched(typeSymbol))
                {
                    return amb;
                }             
            }
            throw new Exception(string.Format("Unknow Argument Symbol:{0}.",typeSymbol));
        }

    }
} 
